#include-once

#include "GUIConstants.au3"
#include "Math.au3"
#include "OnEvent.au3"

Opt( "GUIOnEventMode", 1 )

Local $ctrlInput

Func _ChangeVorzeichen( $aID )
	Local $lRead = GUICtrlRead( $aID ), $lVorzeichen = StringLeft( $lRead, 1 )
	If $lRead = "" Then Return False
	Switch $lVorzeichen
		Case "-"
			GUICtrlSetData( $aID, StringTrimLeft( $lRead, 1 ) )
		Case Else
			GUICtrlSetData( $aID, "-" & $lRead )
	EndSwitch
EndFunc

Func _AddChar( $aID, $aChar )
	Local $lRead = GUICtrlRead( $aID )
	If $lRead = "" Then Return False
	If _CheckLast( $aID ) = 1 Then GUICtrlSetData( $aID, GUICtrlRead( $aID ) & $aChar )
EndFunc

Func _CheckLast( $aID )
	Local $lRead = GUICtrlRead( $aID ) 
	Local $lRight = StringRight( $lRead , 1 )
	Switch $lRight
		Case "*", "/", "-", "+", "^", "."
			Return 0
		Case Else
			Return 1
	EndSwitch
EndFunc

Func _ExecuteHotkey()
	If WinActive( "Calculator" ) Then 
		GUICtrlSetData( $ctrlInput, Execute( GUICtrlRead( $ctrlInput ) ) )
	Else
		HotKeySet( "{NUMPADENTER}" )
		Send( "{NUMPADENTER}" )
		HotKeySet( "{NUMPADENTER}", "_ExecuteHotkey")
		MsgBox( 0, "", "")
	EndIf
EndFunc

Func _Execute( $aID)
	GUICtrlSetData( $aID, Execute( GUICtrlRead( $aID ) ) )	
	GUICtrlSetData( $ctrlInput, Execute( GUICtrlRead( $ctrlInput ) ) )
EndFunc

Func _ClearID( $aID )
	GUICtrlSetData( $aID, "" )
	GUICtrlSetState( $aID, $GUI_FOCUS )
EndFunc

Func _BlockAtoZ( $aID )
	$lCheck = StringSplit("a|b|c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z", "|")
	For $lNum = 1 to $lCheck[0]
		If StringInStr( GUICtrlRead( $aID ) , $lCheck[$lNum] ) Then GUICtrlSetData( $aID, StringReplace( GUICtrlRead( $aID ) , $lCheck[$lNum], "" ) )
	Next
EndFunc

Func _CheckForPrime( $aNumber )
	Local $lCheck = _isPrime( $aNumber )
	Local $lArr[2] = [ "This number is no prime number", "This number is a prime number" ]
	Tooltip( $lArr[$lCheck] )
EndFunc

Func _isPrime( $aNum )
	If $aNum <> 3 And $aNum <> 5 And $aNum <> 7 And $aNum <> 2 Then
		$I_Result1 = _MathCheckDiv( $aNum, 2)
		$I_Result2 = _MathCheckDiv( $aNum, 3)
		$I_Result3 = _MathCheckDiv( $aNum, 5)
		$I_Result4 = _MathCheckDiv( $aNum, 7)
		If $I_Result1 = 2 Or $I_Result2 = 2 Or $I_Result3 = 3 Or $I_Result4 = 2 Then
			Return 0
		Else
			$lSqrt = Sqrt( $aNum )
			$lRound = Round( $lSqrt, 0)
			If $lSqrt = $lRound Then
				Return 0
			Else
				Return 1
			EndIf
		EndIf
	Else
		Return 1
	EndIf
EndFunc   ;==>_isPrime